//----------------------------------------Liberies including----------------------------------//

#include <ax12.h>                                                 // Liberies for ax12 servo drive	
#include <Wire.h>                                                 // Liberies for I2C bus

//----------------------------------------Defining -------------------------------------------//

#define BUTTON0 0                                                 // Defining the Input Button on input 0

//----------------------------------------Position Array--------------------------------------//
int positions[4][5] = {
  {512,512,512,512,512}, 		                          // Pos 0  - Home pos
  {749,512,512,512,512}, 					  // Pos 0  - Ready pos
  {876,550,772,399,512}, 					  // Pos 2  - Before / After push
  {876,680,768,392,512}  					  // Pos 2  - Push
};
//----------------------------------------Variables-------------------------------------------//

int id;	                                                          // defining "id" to Integer
int pos;                                                          // defining "pos" to Integer
int steps;                                                        // defining "steps" to Integer
int Bit;                                                          // defining "Bit" to Integer
int Place;                                                        // defining "Place" to Integer
int master;                                                       // defining "master" to Integer
int slave9;                                                       // defining "slave9" to Integer
int slave8;                                                       // defining "slave8" to Integer
int slave8_send;                                                  // defining "slave8_send" to Integer
int slave9_send;                                                  // defining "slave9_send" to Integer
int moving;                                                       // defining "moving" to Integer

//----------------------------------------Artix-M Board setup---------------------------------//

void setup()
{        
  Serial.begin(19200); 						  // opens serial port, sets data rate to 9600 bps
  Wire.begin();        						  // join i2c bus (address optional for master)
  delay (3000);   						  // Wait 3 sec
  Serial.println("#################################");    	  // Print
  Serial.println("Serial Communication Established.");            // Print
  Serial.println("#################################");            // Print
  Serial.println(" ");                                            // Print
  pinMode(BUTTON0, INPUT);                                        // Set pin mode 0 to input
  steps = 0;							  // Initializing "steps" to 0
  slave8_send = 0;                                                // Initializing "slave8_send" to 0
  Serial.println("slave 8 send 0");                               // Print
  slave9_send = 0;                                                // Initializing "slave9_send" to 0
  Serial.println("slave 9 send 0");                               // Print
}

//----------------------------------------Program looping----------------------------------//
void loop() 
{  
//----------------------------------------Steps Programming--------------------------------//

  delay(100);   						  // Wait 0.1 sec
  /////// Wire request from Slave /////// 
  Wire.requestFrom(8, 1);    					  // request 1 bytes from slave device #8
  while (Wire.available()) 					  // While wire is available 
  { 					 						  
    slave8 = Wire.read(); 		           		  // receive a byte 
  }						                                 
  Serial.print("slave8 : ");    				  // print
  Serial.println(slave8);       		         	  // print
								                                  
  Wire.requestFrom(9, 1);    					  // request 1 bytes from slave device #9
  while (Wire.available()) 					  // While wire is available
  { 								  						  
    slave9 = Wire.read(); 					  // receive a 
  }								                                  
								                                  
  Serial.print("slave9 : ");  				          // print
  Serial.println(slave9);					  // print


  /////// Wire Transmit to Slave /////// 
  Transmission(8,slave8_send);                                    // Call "Transmission" function at write 2 values 
  Transmission(9,slave9_send);                                    // Call "Transmission" function at write 2 values 
  Serial.print("sender til slave 8 : ");         		  // print
  Serial.println(slave8_send);        			 	  // print
  Serial.print("Sender til slave 9: ");         		  // print
  Serial.println(slave9_send);         				  // print
  Serial.print("steps :");         				  // print
  Serial.println(steps);        				  // print

    /////// Step program /////// 
  if (steps == 0)						  // If statement
  {
    Serial.println("Program in step 0");        		  // print

    Serial.println("Run arm to homing position");        	  // print
    ServoRunnigPos(0);						  // Call "ServoRunnigPos" function at write 0

    Serial.println("Set step to 1");        			  // print
    steps = 1;							  // Initializing "steps" to 1
    Serial.println("wait for signal slave 1 and slave 2");        // print
  }

  // Ready step for slave 1, slave 2 and master
  if (steps == 1 && slave8 == 1 && slave9 == 1)                   // If statement
  {                                                              
    Serial.println("Program in step 1");                          // print
                                                                 
    Serial.println("Run arm to ready position");                  // print
    ServoRunnigPos(1);                                            // Call "ServoRunnigPos" function at write 1
    Serial.println("send slave 8");                               // print
    slave8_send = 1;                                              // Initializing "slave8_send" to 1
    Serial.println("send slave 9");                               // print
    slave9_send = 1;                                              // Initializing "slave9_send" to 1

    Serial.println("Set step to 2");		                  // print
    Serial.println("wait for signal pallet");                     // print
    steps = 2;						          // Initializing "steps" to 2
  }

  //pallet 1 step
  if (steps == 2 && slave9 == 3)                                  // If statement
  {
    Serial.println("Program in pallet 1 step 2");                 // print

    Serial.println("Turn ready signal on");                       // print
    slave9_send = 3;                                              // Initializing "slave9_send" to 3

    Serial.println("Set step to 3");                              // print
    Serial.println("wait for signal");                            // print
    steps = 3;						          // Initializing "steps" to 3
  }
  
  //pallet 2 step
  if (steps == 2 && slave9 == 4)                                  // If statement
  {
    Serial.println("Program in pallet 2 step 2");                 // print

    Serial.println("Turn ready signal on");                       // print
    slave9_send = 4;                                              // Initializing "slave9_send" to 4

    Serial.println("Set step to 3");                              // print
    Serial.println("wait for signal");                            // print
    steps = 3;						          // Initializing "steps" to 3
  }
  
  //pallet before dilivering and dillivering
  if (steps == 3 && slave9 == 5 && slave8 == 2)                   // If statement
  {
    Serial.println("Program in step 3");                          // print

    Serial.println("Turn ready signal on");                       // print
    slave8_send = 2;                                              // Initializing "slave8_send" to 2
    Serial.println("Set step to 4");                              // print
    Serial.println("wait for signal");                            // print
    steps = 4;						          // Initializing "steps" to 4
  }
  
  // pallet grabbet slave 1 send slave 2 to ready
  if (steps == 4 && slave8 == 3)                                  // If statement
  {
    Serial.println("Program in step 4");                          // print

    Serial.println("Turn ready signal on");                       // print
    slave9_send = 5;                                              // Initializing "slave9_send" to 5
    Serial.println("Set step to 5");                              // print
    Serial.println("wait slave 2 in ready");                      // print
    steps = 5;						          // Initializing "steps" to 5
  }
  
  // Slave 1 to vinkel
  if (steps == 5 && slave9 == 1)                                  // If statement
  {
    Serial.println("Program in step 5");                          // print
    slave8_send = 3;		                                  // Initializing "slave8_send" to 3

    Serial.println("Set step to 6");                              // print
    Serial.println("wait slave 1 in vinkel");                     // print
    steps = 6;                                                    // Initializing "steps" to 6
  }
  
  // Slave 1 to diliver
  if (steps == 6 && digitalRead(0) == HIGH && slave8 == 4)        // If statement
  {
    Serial.println("Program in step 6");                          // print

    Serial.println("Turn ready signal on");	                  // print
    slave8_send = 4;                                              // Initializing "slave8_send" to 5
    Serial.println("Set step to 7");                              // print
    Serial.println("wait slave 1 dilivered");                     // print
    steps = 7;                                                    // Initializing "steps" to 7
  }
  
  // Start lego
  if (steps == 7 && slave8 == 5)                                  // If statement
  {
    Serial.println("Program in step 7");                          // print

    Serial.println("Run arm to before push");                     // print
    ServoRunnigPos(2);                                            // Call "ServoRunnigPos" function at write 2
    Serial.println("Run arm to push");
    ServoRunnigPos(3);                                            // Call "ServoRunnigPos" function at write 3
    Serial.println("Run arm to after push");
    ServoRunnigPos(2);                                            // Call "ServoRunnigPos" function at write 2

    Serial.println("Run arm to ready position");                  // print
    ServoRunnigPos(1);                                            // Call "ServoRunnigPos" function at write 1
    slave8_send = 0;                                              // Initializing "slave8_send" to 0
    slave9_send = 0;	                                          // Initializing "slave9_send" to 0

    Serial.println("Set step to 2");                              // print
    Serial.println("wait slave 1 and slave 2");                   // print
    steps = 1;                                                    // Initializing "steps" to 0
  }

}


//----------------------------------------Servo Running Pos function----------------------------------//
void ServoRunnigPos(int pos)
{
  for (int id = 0; id <= 4; id++) 				  // Setting the position for all servos except the gripper which will be set when the robot is at the end distination.
  {
    delay(10);                                                    // wait 0.01 sec
    ax12SetRegister2(id + 1, 30, positions[pos][id]);             // set axes positions
  }
  delay(100);                                                     // wait 0.1 sec
  moving=1;                                                       // Initializing "moving" to 1
  while (moving != 0)                                             // The program will loop through this while loop until the robot is at its end position and not moving
  {
    delay(100);                                                   // wait 0.1 sec
    moving = ax12GetRegister(1,46,1)                              // checking if the motors are running. If the result is == 0 no servos is moving
    +ax12GetRegister(2,46,1)
    +ax12GetRegister(3,46,1)
    +ax12GetRegister(4,46,1)
    +ax12GetRegister(5,46,1);
  }
  delay(200);                                                     // wait 0.2 sec
}

//----------------------------------------Transmission function----------------------------------//
void Transmission(int a, int b)
{
  Wire.beginTransmission(a); 					  // transmit to device #
  Wire.write(b);       			                          // sends five bytes
  Wire.endTransmission();    					  // stop transmitting
}
